Index: uspace/drv/bus/usb/usbdiag/device.c
===================================================================
--- uspace/drv/bus/usb/usbdiag/device.c	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
+++ uspace/drv/bus/usb/usbdiag/device.c	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
@@ -0,0 +1,143 @@
+/*
+ * Copyright (c) 2017 Petr Manek
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup drvusbdiag
+ * @{
+ */
+/**
+ * @file
+ * Code for managing debug device structures.
+ */
+#include <errno.h>
+#include <str_error.h>
+#include <macros.h>
+#include <usb/debug.h>
+#include <usbdiag_iface.h>
+
+#include "device.h"
+#include "tests.h"
+
+#define NAME "usbdiag"
+
+static usbdiag_iface_t diag_interface = {
+	.burst_intr_in = usbdiag_burst_test_intr_in,
+	.burst_intr_out = usbdiag_burst_test_intr_out,
+	.burst_bulk_in = usbdiag_burst_test_bulk_in,
+	.burst_bulk_out = usbdiag_burst_test_bulk_out,
+	.burst_isoch_in = usbdiag_burst_test_isoch_in,
+	.burst_isoch_out = usbdiag_burst_test_isoch_out,
+	.data_intr_in = usbdiag_data_test_intr_in,
+	.data_intr_out = usbdiag_data_test_intr_out,
+	.data_bulk_in = usbdiag_data_test_bulk_in,
+	.data_bulk_out = usbdiag_data_test_bulk_out,
+	.data_isoch_in = usbdiag_data_test_isoch_in,
+	.data_isoch_out = usbdiag_data_test_isoch_out
+};
+
+static ddf_dev_ops_t diag_ops = {
+	.interfaces[USBDIAG_DEV_IFACE] = &diag_interface
+};
+
+static int device_init(usbdiag_dev_t *dev, const usb_endpoint_description_t **endpoints)
+{
+	int rc;
+	ddf_fun_t *fun = usb_device_ddf_fun_create(dev->usb_dev, fun_exposed, "tmon");
+	if (!fun) {
+		rc = ENOMEM;
+		goto err;
+	}
+
+	ddf_fun_set_ops(fun, &diag_ops);
+	dev->fun = fun;
+
+#define _MAP_EP(target, ep_no) do {\
+	usb_endpoint_mapping_t *epm = usb_device_get_mapped_ep_desc(dev->usb_dev, endpoints[USBDIAG_EP_##ep_no]);\
+	if (!epm || !epm->present) {\
+		usb_log_error("Failed to map endpoint: " #ep_no ".");\
+		rc = ENOENT;\
+		goto err_fun;\
+	}\
+	target = &epm->pipe;\
+	} while (0);
+
+	_MAP_EP(dev->intr_in, INTR_IN);
+	_MAP_EP(dev->intr_out, INTR_OUT);
+	_MAP_EP(dev->bulk_in, BULK_IN);
+	_MAP_EP(dev->bulk_out, BULK_OUT);
+	_MAP_EP(dev->isoch_in, ISOCH_IN);
+	_MAP_EP(dev->isoch_out, ISOCH_OUT);
+
+#undef _MAP_EP
+
+	return EOK;
+
+err_fun:
+	ddf_fun_destroy(fun);
+err:
+	return rc;
+}
+
+static void device_fini(usbdiag_dev_t *dev)
+{
+	ddf_fun_destroy(dev->fun);
+}
+
+int usbdiag_dev_create(usb_device_t *dev, usbdiag_dev_t **out_diag_dev, const usb_endpoint_description_t **endpoints)
+{
+	assert(dev);
+	assert(out_diag_dev);
+
+	usbdiag_dev_t *diag_dev = usb_device_data_alloc(dev, sizeof(usbdiag_dev_t));
+	if (!diag_dev)
+		return ENOMEM;
+
+	diag_dev->usb_dev = dev;
+
+	int err;
+	if ((err = device_init(diag_dev, endpoints)))
+		goto err_init;
+
+	*out_diag_dev = diag_dev;
+	return EOK;
+
+err_init:
+	/* There is no usb_device_data_free. */
+	return err;
+}
+
+void usbdiag_dev_destroy(usbdiag_dev_t *dev)
+{
+	assert(dev);
+
+	device_fini(dev);
+	/* There is no usb_device_data_free. */
+}
+
+/**
+ * @}
+ */
Index: uspace/drv/bus/usb/usbdiag/device.h
===================================================================
--- uspace/drv/bus/usb/usbdiag/device.h	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
+++ uspace/drv/bus/usb/usbdiag/device.h	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
@@ -0,0 +1,88 @@
+/*
+ * Copyright (c) 2017 Petr Manek
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup drvusbdiag
+ * @{
+ */
+/** @file
+ * USB diagnostic device structures.
+ */
+
+#ifndef USBDIAG_DEVICE_H_
+#define USBDIAG_DEVICE_H_
+
+#include <usb/dev/device.h>
+#include <usb/dev/driver.h>
+
+#define USBDIAG_EP_INTR_IN    1
+#define USBDIAG_EP_INTR_OUT   2
+#define USBDIAG_EP_BULK_IN    3
+#define USBDIAG_EP_BULK_OUT   4
+#define USBDIAG_EP_ISOCH_IN   5
+#define USBDIAG_EP_ISOCH_OUT  6
+
+/**
+ * USB diagnostic device.
+ */
+typedef struct usbdiag_dev {
+	usb_device_t *usb_dev;
+	ddf_fun_t *fun;
+	usb_pipe_t *intr_in;
+	usb_pipe_t *intr_out;
+	usb_pipe_t *bulk_in;
+	usb_pipe_t *bulk_out;
+	usb_pipe_t *isoch_in;
+	usb_pipe_t *isoch_out;
+} usbdiag_dev_t;
+
+int usbdiag_dev_create(usb_device_t *, usbdiag_dev_t **, const usb_endpoint_description_t **);
+void usbdiag_dev_destroy(usbdiag_dev_t *);
+
+static inline usbdiag_dev_t * usb_device_to_usbdiag_dev(usb_device_t *usb_dev)
+{
+	assert(usb_dev);
+	return usb_device_data_get(usb_dev);
+}
+
+static inline usbdiag_dev_t * ddf_dev_to_usbdiag_dev(ddf_dev_t *ddf_dev)
+{
+	assert(ddf_dev);
+	return usb_device_to_usbdiag_dev(usb_device_get(ddf_dev));
+}
+
+static inline usbdiag_dev_t * ddf_fun_to_usbdiag_dev(ddf_fun_t *ddf_fun)
+{
+	assert(ddf_fun);
+	return ddf_dev_to_usbdiag_dev(ddf_fun_get_dev(ddf_fun));
+}
+
+#endif /* USBDIAG_USBDIAG_H_ */
+
+/**
+ * @}
+ */
Index: uspace/drv/bus/usb/usbdiag/main.c
===================================================================
--- uspace/drv/bus/usb/usbdiag/main.c	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
+++ uspace/drv/bus/usb/usbdiag/main.c	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
@@ -0,0 +1,227 @@
+/*
+ * Copyright (c) 2017 Petr Manek
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup drvusbdiag
+ * @{
+ */
+/**
+ * @file
+ * Main routines of USB diagnostic device driver.
+ */
+#include <errno.h>
+#include <usb/debug.h>
+#include <usb/classes/classes.h>
+#include <usb/dev/driver.h>
+#include <usbdiag_iface.h>
+#include <str_error.h>
+
+#include "device.h"
+
+#define NAME "usbdiag"
+
+static const usb_endpoint_description_t *diag_endpoints[];
+
+static int device_add(usb_device_t *dev)
+{
+	int rc;
+	usb_log_info("Adding device '%s'", usb_device_get_name(dev));
+
+	usbdiag_dev_t *diag_dev;
+	if ((rc = usbdiag_dev_create(dev, &diag_dev, diag_endpoints))) {
+		usb_log_error("Failed create device: %s.", str_error(rc));
+		goto err;
+	}
+
+	if ((rc = ddf_fun_bind(diag_dev->fun))) {
+		usb_log_error("Failed to bind DDF function: %s.", str_error(rc));
+		goto err_create;
+	}
+
+	if ((rc = ddf_fun_add_to_category(diag_dev->fun, USBDIAG_CATEGORY))) {
+		usb_log_error("Failed add DDF to category '"
+		    USBDIAG_CATEGORY "': %s.\n", str_error(rc));
+		goto err_bind;
+	}
+
+	return EOK;
+
+err_bind:
+	ddf_fun_unbind(diag_dev->fun);
+err_create:
+	usbdiag_dev_destroy(diag_dev);
+err:
+	return rc;
+}
+
+static int device_cleanup(usbdiag_dev_t *diag_dev)
+{
+	/* TODO: Join some fibrils? */
+
+	/* Free memory. */
+	usbdiag_dev_destroy(diag_dev);
+	return EOK;
+}
+
+static int device_remove(usb_device_t *dev)
+{
+	int rc;
+	usb_log_info("Removing device '%s'", usb_device_get_name(dev));
+
+	usbdiag_dev_t *diag_dev = usb_device_to_usbdiag_dev(dev);
+
+	/* TODO: Make sure nothing is going on with the device. */
+
+	if ((rc = ddf_fun_unbind(diag_dev->fun))) {
+		usb_log_error("Failed to unbind DDF function: %s", str_error(rc));
+		goto err;
+	}
+
+	usb_log_info("Device '%s' removed.", usb_device_get_name(dev));
+	return device_cleanup(diag_dev);
+
+err:
+	return rc;
+}
+
+static int device_gone(usb_device_t *dev)
+{
+	int rc;
+	usb_log_info("Device '%s' gone.", usb_device_get_name(dev));
+
+	usbdiag_dev_t *diag_dev = usb_device_to_usbdiag_dev(dev);
+
+	/* TODO: Make sure nothing is going on with the device. */
+
+	if ((rc = ddf_fun_unbind(diag_dev->fun))) {
+		usb_log_error("Failed to unbind DDF function: %s", str_error(rc));
+		goto err;
+	}
+
+	return device_cleanup(diag_dev);
+
+err:
+	return rc;
+}
+
+static int function_online(ddf_fun_t *fun)
+{
+	return ddf_fun_online(fun);
+}
+
+static int function_offline(ddf_fun_t *fun)
+{
+	return ddf_fun_offline(fun);
+}
+
+static const usb_endpoint_description_t intr_in_ep = {
+	.transfer_type = USB_TRANSFER_INTERRUPT,
+	.direction = USB_DIRECTION_IN,
+	.interface_class = USB_CLASS_DIAGNOSTIC,
+	.interface_subclass = 0x00,
+	.interface_protocol = 0x01,
+	.flags = 0
+};
+static const usb_endpoint_description_t intr_out_ep = {
+	.transfer_type = USB_TRANSFER_INTERRUPT,
+	.direction = USB_DIRECTION_OUT,
+	.interface_class = USB_CLASS_DIAGNOSTIC,
+	.interface_subclass = 0x00,
+	.interface_protocol = 0x01,
+	.flags = 0
+};
+static const usb_endpoint_description_t bulk_in_ep = {
+	.transfer_type = USB_TRANSFER_BULK,
+	.direction = USB_DIRECTION_IN,
+	.interface_class = USB_CLASS_DIAGNOSTIC,
+	.interface_subclass = 0x00,
+	.interface_protocol = 0x01,
+	.flags = 0
+};
+static const usb_endpoint_description_t bulk_out_ep = {
+	.transfer_type = USB_TRANSFER_BULK,
+	.direction = USB_DIRECTION_OUT,
+	.interface_class = USB_CLASS_DIAGNOSTIC,
+	.interface_subclass = 0x00,
+	.interface_protocol = 0x01,
+	.flags = 0
+};
+static const usb_endpoint_description_t isoch_in_ep = {
+	.transfer_type = USB_TRANSFER_ISOCHRONOUS,
+	.direction = USB_DIRECTION_IN,
+	.interface_class = USB_CLASS_DIAGNOSTIC,
+	.interface_subclass = 0x00,
+	.interface_protocol = 0x01,
+	.flags = 0
+};
+static const usb_endpoint_description_t isoch_out_ep = {
+	.transfer_type = USB_TRANSFER_ISOCHRONOUS,
+	.direction = USB_DIRECTION_OUT,
+	.interface_class = USB_CLASS_DIAGNOSTIC,
+	.interface_subclass = 0x00,
+	.interface_protocol = 0x01,
+	.flags = 0
+};
+
+static const usb_endpoint_description_t *diag_endpoints[] = {
+	[USBDIAG_EP_INTR_IN] = &intr_in_ep,
+	[USBDIAG_EP_INTR_OUT] = &intr_out_ep,
+	[USBDIAG_EP_BULK_IN] = &bulk_in_ep,
+	[USBDIAG_EP_BULK_OUT] = &bulk_out_ep,
+	[USBDIAG_EP_ISOCH_IN] = &isoch_in_ep,
+	[USBDIAG_EP_ISOCH_OUT] = &isoch_out_ep,
+	NULL
+};
+
+/** USB diagnostic driver ops. */
+static const usb_driver_ops_t diag_driver_ops = {
+	.device_add = device_add,
+	.device_remove = device_remove,
+	.device_gone = device_gone,
+	.function_online = function_online,
+	.function_offline = function_offline
+};
+
+/** USB diagnostic driver. */
+static const usb_driver_t diag_driver = {
+	.name = NAME,
+	.ops = &diag_driver_ops,
+	.endpoints = &diag_endpoints[1] /* EPs are indexed from 1. */
+};
+
+int main(int argc, char *argv[])
+{
+	printf(NAME ": USB diagnostic device driver.\n");
+
+	log_init(NAME);
+
+	return usb_driver_main(&diag_driver);
+}
+
+/**
+ * @}
+ */
Index: uspace/drv/bus/usb/usbdiag/tests.c
===================================================================
--- uspace/drv/bus/usb/usbdiag/tests.c	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
+++ uspace/drv/bus/usb/usbdiag/tests.c	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
@@ -0,0 +1,375 @@
+/*
+ * Copyright (c) 2017 Petr Manek
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup drvusbdiag
+ * @{
+ */
+/**
+ * @file
+ * Code for executing diagnostic tests.
+ */
+#include <errno.h>
+#include <str_error.h>
+#include <usb/debug.h>
+#include <usbdiag_iface.h>
+#include <time.h>
+#include "device.h"
+#include "tests.h"
+
+#define NAME "usbdiag"
+
+static int burst_in_test(usb_pipe_t *pipe, int cycles, size_t size, usbdiag_dur_t *duration)
+{
+	if (!pipe)
+		return EBADMEM;
+
+	char *buffer = (char *) malloc(size);
+	if (!buffer)
+		return ENOMEM;
+
+	// TODO: Are we sure that no other test is running on this endpoint?
+
+	usb_log_info("Performing %s IN burst test.", usb_str_transfer_type(pipe->desc.transfer_type));
+
+	int rc = EOK;
+	struct timeval start_time;
+	gettimeofday(&start_time, NULL);
+
+	for (int i = 0; i < cycles; ++i) {
+		// Read device's response.
+		size_t remaining = size;
+		size_t transferred;
+
+		while (remaining > 0) {
+			if ((rc = usb_pipe_read(pipe, buffer + size - remaining, remaining, &transferred))) {
+				usb_log_error("Read of %s IN endpoint failed with error: %s", usb_str_transfer_type(pipe->desc.transfer_type), str_error(rc));
+				break;
+			}
+
+			if (transferred > remaining) {
+				usb_log_error("Read of %s IN endpoint returned more data than expected.", usb_str_transfer_type(pipe->desc.transfer_type));
+				rc = EINVAL;
+				break;
+			}
+
+			remaining -= transferred;
+		}
+
+		if (rc)
+			break;
+	}
+
+	struct timeval final_time;
+	gettimeofday(&final_time, NULL);
+	usbdiag_dur_t in_duration = ((final_time.tv_usec - start_time.tv_usec) / 1000) +
+	    ((final_time.tv_sec - start_time.tv_sec) * 1000);
+
+	usb_log_info("Burst test on %s IN endpoint completed in %lu ms.", usb_str_transfer_type(pipe->desc.transfer_type), in_duration);
+
+	free(buffer);
+	if (duration)
+		*duration = in_duration;
+
+	return rc;
+}
+
+static int burst_out_test(usb_pipe_t *pipe, int cycles, size_t size, usbdiag_dur_t *duration)
+{
+	if (!pipe)
+		return EBADMEM;
+
+	char *buffer = (char *) malloc(size);
+	if (!buffer)
+		return ENOMEM;
+
+	memset(buffer, 42, size);
+
+	// TODO: Are we sure that no other test is running on this endpoint?
+
+	usb_log_info("Performing %s OUT burst test.", usb_str_transfer_type(pipe->desc.transfer_type));
+
+	int rc = EOK;
+	struct timeval start_time;
+	gettimeofday(&start_time, NULL);
+
+	for (int i = 0; i < cycles; ++i) {
+		// Write buffer to device.
+		if ((rc = usb_pipe_write(pipe, buffer, size))) {
+			usb_log_error("Write to %s OUT endpoint failed with error: %s", usb_str_transfer_type(pipe->desc.transfer_type), str_error(rc));
+			break;
+		}
+	}
+
+	struct timeval final_time;
+	gettimeofday(&final_time, NULL);
+	usbdiag_dur_t in_duration = ((final_time.tv_usec - start_time.tv_usec) / 1000) +
+	    ((final_time.tv_sec - start_time.tv_sec) * 1000);
+
+	usb_log_info("Burst test on %s OUT endpoint completed in %ld ms.", usb_str_transfer_type(pipe->desc.transfer_type), in_duration);
+
+	free(buffer);
+	if (duration)
+		*duration = in_duration;
+
+	return rc;
+}
+
+static const uint32_t test_data_src = 0xDEADBEEF;
+
+static int data_in_test(usb_pipe_t *pipe, int cycles, size_t size, usbdiag_dur_t *duration)
+{
+	if (!pipe)
+		return EBADMEM;
+
+	const uint32_t test_data = uint32_host2usb(test_data_src);
+
+	if (size % sizeof(test_data))
+		return EINVAL;
+
+	char *buffer = (char *) malloc(size);
+	if (!buffer)
+		return ENOMEM;
+
+	// TODO: Are we sure that no other test is running on this endpoint?
+
+	usb_log_info("Performing %s IN data test.", usb_str_transfer_type(pipe->desc.transfer_type));
+
+	int rc = EOK;
+	struct timeval start_time;
+	gettimeofday(&start_time, NULL);
+
+	for (int i = 0; i < cycles; ++i) {
+		// Read device's response.
+		size_t remaining = size;
+		size_t transferred;
+
+		while (remaining > 0) {
+			if ((rc = usb_pipe_read(pipe, buffer + size - remaining, remaining, &transferred))) {
+				usb_log_error("Read of %s IN endpoint failed with error: %s", usb_str_transfer_type(pipe->desc.transfer_type), str_error(rc));
+				break;
+			}
+
+			if (transferred > remaining) {
+				usb_log_error("Read of %s IN endpoint returned more data than expected.", usb_str_transfer_type(pipe->desc.transfer_type));
+				rc = EINVAL;
+				break;
+			}
+
+			remaining -= transferred;
+		}
+
+		if (rc)
+			break;
+
+		for (size_t i = 0; i < size; i += sizeof(test_data)) {
+			if (*(uint32_t *)(buffer + i) != test_data) {
+				usb_log_error("Read of %s IN endpoint returned "
+				    "invald data at address %zu.",
+				    usb_str_transfer_type(pipe->desc.transfer_type), i);
+				rc = EINVAL;
+				break;
+			}
+		}
+
+		if (rc)
+			break;
+	}
+
+	struct timeval final_time;
+	gettimeofday(&final_time, NULL);
+	usbdiag_dur_t in_duration = ((final_time.tv_usec - start_time.tv_usec) / 1000) +
+	    ((final_time.tv_sec - start_time.tv_sec) * 1000);
+
+	usb_log_info("Data test on %s IN endpoint completed in %lu ms.", usb_str_transfer_type(pipe->desc.transfer_type), in_duration);
+
+	free(buffer);
+	if (duration)
+		*duration = in_duration;
+
+	return rc;
+}
+
+static int data_out_test(usb_pipe_t *pipe, int cycles, size_t size, usbdiag_dur_t *duration)
+{
+	if (!pipe)
+		return EBADMEM;
+
+	const uint32_t test_data = uint32_host2usb(test_data_src);
+
+	if (size % sizeof(test_data))
+		return EINVAL;
+
+	char *buffer = (char *) malloc(size);
+	if (!buffer)
+		return ENOMEM;
+
+	for (size_t i = 0; i < size; i += sizeof(test_data)) {
+		memcpy(buffer + i, &test_data, sizeof(test_data));
+	}
+
+	// TODO: Are we sure that no other test is running on this endpoint?
+
+	usb_log_info("Performing %s OUT data test.", usb_str_transfer_type(pipe->desc.transfer_type));
+
+	int rc = EOK;
+	struct timeval start_time;
+	gettimeofday(&start_time, NULL);
+
+	for (int i = 0; i < cycles; ++i) {
+		// Write buffer to device.
+		if ((rc = usb_pipe_write(pipe, buffer, size))) {
+			usb_log_error("Write to %s OUT endpoint failed with error: %s", usb_str_transfer_type(pipe->desc.transfer_type), str_error(rc));
+			break;
+		}
+	}
+
+	struct timeval final_time;
+	gettimeofday(&final_time, NULL);
+	usbdiag_dur_t in_duration = ((final_time.tv_usec - start_time.tv_usec) / 1000) +
+	    ((final_time.tv_sec - start_time.tv_sec) * 1000);
+
+	usb_log_info("Data test on %s OUT endpoint completed in %ld ms.", usb_str_transfer_type(pipe->desc.transfer_type), in_duration);
+
+	free(buffer);
+	if (duration)
+		*duration = in_duration;
+
+	return rc;
+}
+
+int usbdiag_burst_test_intr_in(ddf_fun_t *fun, int cycles, size_t size, usbdiag_dur_t *duration)
+{
+	usbdiag_dev_t *dev = ddf_fun_to_usbdiag_dev(fun);
+	if (!dev)
+		return EBADMEM;
+
+	return burst_in_test(dev->intr_in, cycles, size, duration);
+}
+
+int usbdiag_burst_test_intr_out(ddf_fun_t *fun, int cycles, size_t size, usbdiag_dur_t *duration)
+{
+	usbdiag_dev_t *dev = ddf_fun_to_usbdiag_dev(fun);
+	if (!dev)
+		return EBADMEM;
+
+	return burst_out_test(dev->intr_out, cycles, size, duration);
+}
+
+int usbdiag_burst_test_bulk_in(ddf_fun_t *fun, int cycles, size_t size, usbdiag_dur_t *duration)
+{
+	usbdiag_dev_t *dev = ddf_fun_to_usbdiag_dev(fun);
+	if (!dev)
+		return EBADMEM;
+
+	return burst_in_test(dev->bulk_in, cycles, size, duration);
+}
+
+int usbdiag_burst_test_bulk_out(ddf_fun_t *fun, int cycles, size_t size, usbdiag_dur_t *duration)
+{
+	usbdiag_dev_t *dev = ddf_fun_to_usbdiag_dev(fun);
+	if (!dev)
+		return EBADMEM;
+
+	return burst_out_test(dev->bulk_out, cycles, size, duration);
+}
+
+int usbdiag_burst_test_isoch_in(ddf_fun_t *fun, int cycles, size_t size, usbdiag_dur_t *duration)
+{
+	usbdiag_dev_t *dev = ddf_fun_to_usbdiag_dev(fun);
+	if (!dev)
+		return EBADMEM;
+
+	return burst_in_test(dev->isoch_in, cycles, size, duration);
+}
+
+int usbdiag_burst_test_isoch_out(ddf_fun_t *fun, int cycles, size_t size, usbdiag_dur_t *duration)
+{
+	usbdiag_dev_t *dev = ddf_fun_to_usbdiag_dev(fun);
+	if (!dev)
+		return EBADMEM;
+
+	return burst_out_test(dev->isoch_out, cycles, size, duration);
+}
+
+int usbdiag_data_test_intr_in(ddf_fun_t *fun, int cycles, size_t size, usbdiag_dur_t *duration)
+{
+	usbdiag_dev_t *dev = ddf_fun_to_usbdiag_dev(fun);
+	if (!dev)
+		return EBADMEM;
+
+	return data_in_test(dev->intr_in, cycles, size, duration);
+}
+
+int usbdiag_data_test_intr_out(ddf_fun_t *fun, int cycles, size_t size, usbdiag_dur_t *duration)
+{
+	usbdiag_dev_t *dev = ddf_fun_to_usbdiag_dev(fun);
+	if (!dev)
+		return EBADMEM;
+
+	return data_out_test(dev->intr_out, cycles, size, duration);
+}
+
+int usbdiag_data_test_bulk_in(ddf_fun_t *fun, int cycles, size_t size, usbdiag_dur_t *duration)
+{
+	usbdiag_dev_t *dev = ddf_fun_to_usbdiag_dev(fun);
+	if (!dev)
+		return EBADMEM;
+
+	return data_in_test(dev->bulk_in, cycles, size, duration);
+}
+
+int usbdiag_data_test_bulk_out(ddf_fun_t *fun, int cycles, size_t size, usbdiag_dur_t *duration)
+{
+	usbdiag_dev_t *dev = ddf_fun_to_usbdiag_dev(fun);
+	if (!dev)
+		return EBADMEM;
+
+	return data_out_test(dev->bulk_out, cycles, size, duration);
+}
+
+int usbdiag_data_test_isoch_in(ddf_fun_t *fun, int cycles, size_t size, usbdiag_dur_t *duration)
+{
+	usbdiag_dev_t *dev = ddf_fun_to_usbdiag_dev(fun);
+	if (!dev)
+		return EBADMEM;
+
+	return data_in_test(dev->isoch_in, cycles, size, duration);
+}
+
+int usbdiag_data_test_isoch_out(ddf_fun_t *fun, int cycles, size_t size, usbdiag_dur_t *duration)
+{
+	usbdiag_dev_t *dev = ddf_fun_to_usbdiag_dev(fun);
+	if (!dev)
+		return EBADMEM;
+
+	return data_out_test(dev->isoch_out, cycles, size, duration);
+}
+
+/**
+ * @}
+ */
Index: uspace/drv/bus/usb/usbdiag/tests.h
===================================================================
--- uspace/drv/bus/usb/usbdiag/tests.h	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
+++ uspace/drv/bus/usb/usbdiag/tests.h	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
@@ -0,0 +1,59 @@
+/*
+ * Copyright (c) 2017 Petr Manek
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup drvusbdiag
+ * @{
+ */
+/** @file
+ * USB diagnostic tests.
+ */
+
+#ifndef USBDIAG_TESTS_H_
+#define USBDIAG_TESTS_H_
+
+#include <ddf/driver.h>
+
+int usbdiag_burst_test_intr_in(ddf_fun_t *, int, size_t, usbdiag_dur_t *);
+int usbdiag_burst_test_intr_out(ddf_fun_t *, int, size_t, usbdiag_dur_t *);
+int usbdiag_burst_test_bulk_in(ddf_fun_t *, int, size_t, usbdiag_dur_t *);
+int usbdiag_burst_test_bulk_out(ddf_fun_t *, int, size_t, usbdiag_dur_t *);
+int usbdiag_burst_test_isoch_in(ddf_fun_t *, int, size_t, usbdiag_dur_t *);
+int usbdiag_burst_test_isoch_out(ddf_fun_t *, int, size_t, usbdiag_dur_t *);
+
+int usbdiag_data_test_intr_in(ddf_fun_t *, int, size_t, usbdiag_dur_t *);
+int usbdiag_data_test_intr_out(ddf_fun_t *, int, size_t, usbdiag_dur_t *);
+int usbdiag_data_test_bulk_in(ddf_fun_t *, int, size_t, usbdiag_dur_t *);
+int usbdiag_data_test_bulk_out(ddf_fun_t *, int, size_t, usbdiag_dur_t *);
+int usbdiag_data_test_isoch_in(ddf_fun_t *, int, size_t, usbdiag_dur_t *);
+int usbdiag_data_test_isoch_out(ddf_fun_t *, int, size_t, usbdiag_dur_t *);
+
+#endif /* USBDIAG_TESTS_H_ */
+
+/**
+ * @}
+ */
Index: uspace/drv/bus/usb/usbdiag/usbdiag.ma
===================================================================
--- uspace/drv/bus/usb/usbdiag/usbdiag.ma	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
+++ uspace/drv/bus/usb/usbdiag/usbdiag.ma	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
@@ -0,0 +1,2 @@
+100 usb&diagnostic
+100 usb&class=diagnostic
Index: uspace/drv/bus/usb/usbflbk/main.c
===================================================================
--- uspace/drv/bus/usb/usbflbk/main.c	(revision 2752620b090f5bf0ecc3baace21dc1fa5da89d73)
+++ uspace/drv/bus/usb/usbflbk/main.c	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
@@ -48,5 +48,5 @@
 static errno_t usbfallback_device_add(usb_device_t *dev)
 {
-	usb_log_info("Pretending to control %s `%s'.\n",
+	usb_log_info("Pretending to control %s `%s'.",
 	    usb_device_get_iface_number(dev) < 0 ? "device" : "interface",
 	    usb_device_get_name(dev));
@@ -62,4 +62,12 @@
 {
 	assert(dev);
+	usb_log_info("Device '%s' gone.", usb_device_get_name(dev));
+	return EOK;
+}
+
+static int usbfallback_device_remove(usb_device_t *dev)
+{
+	assert(dev);
+	usb_log_info("Device '%s' removed.", usb_device_get_name(dev));
 	return EOK;
 }
@@ -68,5 +76,5 @@
 static const usb_driver_ops_t usbfallback_driver_ops = {
 	.device_add = usbfallback_device_add,
-	.device_rem = usbfallback_device_gone,
+	.device_remove = usbfallback_device_remove,
 	.device_gone = usbfallback_device_gone,
 };
Index: uspace/drv/bus/usb/usbhub/main.c
===================================================================
--- uspace/drv/bus/usb/usbhub/main.c	(revision 2752620b090f5bf0ecc3baace21dc1fa5da89d73)
+++ uspace/drv/bus/usb/usbhub/main.c	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
@@ -48,13 +48,8 @@
 static const usb_driver_ops_t usb_hub_driver_ops = {
 	.device_add = usb_hub_device_add,
-//	.device_rem = usb_hub_device_remove,
+	.device_remove = usb_hub_device_remove,
 	.device_gone = usb_hub_device_gone,
 };
 
-/** Hub endpoints, excluding control endpoint. */
-static const usb_endpoint_description_t *usb_hub_endpoints[] = {
-	&hub_status_change_endpoint_description,
-	NULL,
-};
 /** Static usb hub driver information. */
 static const usb_driver_t usb_hub_driver = {
